/**
 * Created by dheninger on 2016-09-15.
 */

@IsTest
private class CO_OptimizationTrackerEditExtTest {
	
	private static String loc = null;
	private static String on_Hold_Status = 'On Hold';
	private static String cancelled_Status = 'Cancelled';
	private static String in_Progress_PE_Status = 'In Progress - Production Engineer';
	private static String in_Progress_G_Status = 'In Progress - Geologist';
	private static String in_Progress_DE_Status = 'In Progress - Development Engineer';
	private static String pending_Managers_Approval_Status = 'Pending Manager\'s Approval';
	private static String approved_Status = 'Approved';
	private static String completed_Status = 'Completed';
	private static String complete_Status = 'Complete';
	private static String notApplicable_Status = 'Not Applicable';
	private static String in_Progress_Status = 'In Progress';
	private static String notRequired = 'Not Required';
	
	static testMethod void testController() {
		
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');

		
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		
		//insert tracker;
		
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		
		System.runAs(runningUser) {
			System.assertEquals(false, controller.getIsHeaderVisible() );
			tracker.Optimization_Request__c = 'Downhole';
			System.assertEquals(true, controller.getIsDownhole() );
			System.assertEquals(false, controller.getIsSurface() );
			
			tracker.Optimization_Request__c = 'Surface';
			System.assertEquals(false, controller.getIsDownhole() );
			System.assertEquals(true, controller.getIsSurface() );

			System.assertEquals(false, controller.getNewFromLocation() );
			test.startTest();
			
			Location__c testLocation = LocationTestData.createLocation();
			System.assertEquals(false, controller.getIsHeaderVisible());
			controller.wot.Optimization_Category__c = 'Capital';
			System.assertEquals(true, controller.getIsHeaderVisible() );
			tracker.Well_Location__c = testLocation.Id;
			System.assertEquals(true, controller.getNewFromLocation() );                    
			
			tracker.Opt_Type__c = 'Recomplete -Plug Back - Bridge Plug';
			System.assertEquals(false, controller.getIsNewWellCompletionStatus());
			tracker.Optimization_Tracker_Status__c = 'On Hold';
			tracker.Reason__c = 'On Hold Reason';
			System.assertEquals(false, controller.getIsApproved() );
			System.assertEquals(true, controller.getIsOnHold() );
			System.assertEquals(false, controller.getIsCancelled() );
			System.assertEquals(true, controller.getIsHeaderVisible() );

			controller.saveTracker();
			
			tracker.Optimization_Tracker_Status__c = 'Cancelled';
			tracker.Reason__c = 'Cancelled Reason';
			System.assertEquals(false, controller.getIsApproved() );
			System.assertEquals(true, controller.getIsCancelled() );
			System.assertEquals(false, controller.getIsOnHold() );
			//System.assertEquals(false, controller.getIsCompleted() );
			controller.saveTracker();
			tracker.Opt_Type__c = null;
			controller.saveTracker();
			
			tracker.Optimization_Tracker_Status__c = 'Completed';
			//System.assertEquals(true, controller.getIsCompleted() );
			
			tracker.Optimization_Tracker_Status__c = 'Approved';
			tracker.Opt_Type__c = 'Recomplete -Plug Back - Bridge Plug';
			tracker.Current_State__c = 'Completed';
			tracker.RMLC_Approval__c = 'Complete';
			tracker.Regulatory_Approvals__c = 'Complete';
			tracker.Financial_Approval__c = 'Complete';
			tracker.Construction__c = 'Complete';
			tracker.Surface_Equipment__c = 'Complete';
			controller.saveTracker();
			
			test.stopTest();
		}

	}
	
   static testMethod void testControllerforSave() {
		
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');

		
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		
		System.runAs(runningUser) {
			RecordType wellLocation = [SELECT Id, Name FROM RecordType WHERE DeveloperName = 'Well_ID' AND SobjectType = 'Location__c' LIMIT 1];
			test.startTest();
			tracker.Optimization_Request__c = 'Downhole';
			
			Location__c testLocation = LocationTestData.createLocation();
			testLocation.RecordTypeId = wellLocation.id;
			update testLocation;

			tracker.Well_Location__c = testLocation.Id;               
			
			tracker.Opt_Type__c = 'Recomplete -Plug Back - Bridge Plug';
			tracker.Optimization_Tracker_Status__c = 'Approved';
		   
			tracker.Opt_Type__c = 'Recomplete -Plug Back - Bridge Plug';
			tracker.Current_State__c = 'Completed';
			tracker.RMLC_Approval__c = 'Complete';
			tracker.Regulatory_Approvals__c = 'Complete';
			tracker.Financial_Approval__c = 'Complete';
			tracker.Construction__c = 'Complete';
			tracker.Surface_Equipment__c = 'Complete';
			
			tracker.Job_Complete_Date__c = date.parse('12/05/2016');
			tracker.RMLC_Complete_Date__c = date.parse('12/05/2016');
			tracker.Regulatory_Approvals_Complete_Date__c = date.parse('12/05/2016');
			tracker.Financial_Approval_Complete_Date__c = date.parse('12/05/2016');
			tracker.Construction_Complete_Date__c = date.parse('12/05/2016');
			tracker.Surface_Equipment_Complete_Date__c = date.parse('12/05/2016');
			tracker.Location_Event__c = 'Well Location';
			
			testLocation.PVR_Produced_Oil__c = 100;
			testLocation.PVR_Produced_Water__c = 100;
			testLocation.PVR_Produced_Sand__c = 100;
			testLocation.PVR_Month_To_Day_Generated__c = date.parse('01/17/2017');
			testLocation.RecordTypeId = wellLocation.Id;
			testLocation.PVR_Hours_On_Prod__c = 10;
			
			ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
			CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
			pageRef.setRedirect(true);
			pageRef.getUrl();
			controller.saveTracker();
			test.stopTest();
		}

	}
	
	static testMethod void testControllerforSaveWithInProgress() {
		
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');

		
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		
		//insert tracker;
		
		System.runAs(runningUser) {
			RecordType wellLocation = [SELECT Id FROM RecordType WHERE DeveloperName = 'Well_ID' AND SobjectType = 'Location__c' LIMIT 1];
			test.startTest();
			tracker.Optimization_Request__c = 'Downhole';
			Location__c testLocation = LocationTestData.createLocation();
			tracker.Well_Location__c = testLocation.Id;               
			
			tracker.Opt_Type__c = 'Recomplete -Plug Back - Bridge Plug';
			tracker.Optimization_Tracker_Status__c = 'Approved';
		   
			tracker.Opt_Type__c = 'Recomplete -Plug Back - Bridge Plug';
			tracker.Current_State__c = 'Completed';
			tracker.RMLC_Approval__c = 'Complete';
			tracker.Regulatory_Approvals__c = 'Complete';
			tracker.Financial_Approval__c = 'Complete';
			tracker.Construction__c = 'In Progress';
			tracker.Surface_Equipment__c = 'In Progress';
			
			tracker.Job_Complete_Date__c = date.parse('12/05/2016');
			tracker.RMLC_Complete_Date__c = date.parse('12/05/2016');
			tracker.Regulatory_Approvals_Complete_Date__c = date.parse('12/05/2016');
			tracker.Financial_Approval_Complete_Date__c = date.parse('12/05/2016');
			tracker.Construction_Complete_Date__c = date.parse('12/05/2016');
			tracker.Surface_Equipment_Complete_Date__c = date.parse('12/05/2016');
			
			testLocation.PVR_Produced_Oil__c = 100;
			testLocation.PVR_Produced_Water__c = 200;
			testLocation.PVR_Produced_Sand__c = 300;
			testLocation.PVR_Month_To_Day_Generated__c = date.parse('01/17/2017');
			testLocation.RecordTypeId = wellLocation.Id;
			testLocation.PVR_Hours_On_Prod__c = 10;
			update testLocation;
			
			RecordType wellID = [SELECT Id FROM RecordType WHERE DeveloperName = 'Well_Id' AND SobjectType = 'Location__c'];
			System.debug('Well Event Name from Lookup: '+testLocation.RecordType.Name);
		 
			ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
			CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
			testLocation.RecordTypeId = wellID.Id;
			update testLocation;
			
			ApexPages.StandardController apexController = new ApexPages.StandardController(tracker);
			CO_OptimizationTrackerEditExt CO_Controller = new CO_OptimizationTrackerEditExt(apexController);
			
			pageRef.setRedirect(true);
			pageRef.getUrl();
			controller.saveTracker();
			test.stopTest();
		}

	}
	
	static testMethod void testForGetWellLocationsData() { 
		
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');

		
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		
		 System.runAs(runningUser) { 
			RecordType wellEvent = [SELECT Id FROM RecordType WHERE DeveloperName = 'Well_Event' AND SobjectType = 'Location__c' LIMIT 1];
			RecordType wellID = [SELECT Id FROM RecordType WHERE DeveloperName = 'Well_Id' AND SobjectType = 'Location__c'];
			Location__c testWellEvent = LocationTestData.createLocation();
		   
			test.startTest();
			Location__c testWellID = LocationTestData.createLocation();
			testWellID.RecordTypeId = wellID.id;
			update testWellID;
			
			testWellEvent.PVR_Produced_Oil__c = 100;
			testWellEvent.PVR_Produced_Water__c = 200;
			testWellEvent.PVR_Produced_Sand__c = 300;
			testWellEvent.PVR_Month_To_Day_Generated__c = date.parse('01/17/2017');
			testWellEvent.RecordTypeId = wellEvent.Id;
			testWellEvent.Well_ID__c = testWellID.Id;
			testWellEvent.PVR_Hours_On_Prod__c = 10;
			update testWellEvent;
			
			Well_Optimization_Tracker__c locTracker = new Well_Optimization_Tracker__c();
			locTracker.Well_Location__c = testWellID.Id;               
			
			locTracker.Opt_Type__c = 'Recomplete -Plug Back - Bridge Plug';
			locTracker.Optimization_Tracker_Status__c = 'Approved';
		   
			locTracker.Opt_Type__c = 'Recomplete -Plug Back - Bridge Plug';
			locTracker.Current_State__c = 'Completed';
			locTracker.RMLC_Approval__c = 'Complete';
			locTracker.Regulatory_Approvals__c = 'Complete';
			locTracker.Financial_Approval__c = 'Complete';
			locTracker.Construction__c = 'In Progress';
			locTracker.Surface_Equipment__c = 'In Progress';
			
			locTracker.Job_Complete_Date__c = date.parse('12/05/2016');
			locTracker.RMLC_Complete_Date__c = date.parse('12/05/2016');
			locTracker.Regulatory_Approvals_Complete_Date__c = date.parse('12/05/2016');
			locTracker.Financial_Approval_Complete_Date__c = date.parse('12/05/2016');
			locTracker.Construction_Complete_Date__c = date.parse('12/05/2016');
			locTracker.Surface_Equipment_Complete_Date__c = date.parse('12/05/2016');
			
			ApexPages.StandardController stdController = new ApexPages.StandardController(locTracker);
			CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
			
			testWellEvent.PVR_Hours_On_Prod__c = null;
			update testWellEvent;
			
			ApexPages.StandardController stController = new ApexPages.StandardController(locTracker);
			CO_OptimizationTrackerEditExt scontroller = new CO_OptimizationTrackerEditExt(stController);
			
			test.stopTest();
		 }
		
		
	}
	
	@isTest static void testAttachments() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');

		
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			prepareWot(controller);
			test.startTest();
			System.assert(controller.attachmentsList != null);
			System.assertEquals(CO_OptimizationTrackerEditExt.NUM_ATTACHMENTS_TO_ADD, controller.attachmentsList.size());

			controller.addAttachment();
			System.assert(controller.attachmentsList != null);
			System.assertEquals(CO_OptimizationTrackerEditExt.NUM_ATTACHMENTS_TO_ADD+CO_OptimizationTrackerEditExt.NUM_ATTACHMENTS_TO_ADD, controller.attachmentsList.size());
			
			controller.attachmentsList = null;
			controller.addAttachment();
			insertTestBadAttachment(controller);
			controller.attachmentsList.get(0).name = 'test';

			controller.saveAttachments();
			System.assertEquals(0, [SELECT count() FROM Well_Optimization_Tracker__c WHERE ID= :tracker.Id]);
			System.assertEquals(0, [SELECT count() FROM Attachment WHERE ParentId= :tracker.Id]);
			controller.attachmentsList.clear();

			controller.addAttachment();
			
			RecordType wellID = [SELECT Id FROM RecordType WHERE DeveloperName = 'Well_ID' AND SobjectType = 'Location__c'];
			Location__c testWellID = LocationTestData.createLocation();
			testWellID.RecordTypeId = wellID.id;
			update testWellID;
			
			controller.wot.Well_Location__c = testWellID.id;
			
			insertTestAttachment(controller, tracker.Id);

			tracker.id = null;
			insert tracker;
			controller.wot.Optimization_Tracker_Status__c = controller.in_Progress_PE_Status;
			controller.wot.Opt_Type__c = 'Add Perfs';
			controller.wot.Predicted_Incremental_Oil_bopd__c = 1;
			controller.wot.Predicted_Incremental_Water_bwpd__c = 1;

			controller.saveAttachments();
			
			test.stopTest();
		}
		
	}
	
	public static testMethod void testAttachmentsMainElseSection() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');

		
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			controller.wot.id = null;
			controller.upsertAttachments();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
		
	}
	
	public static testMethod void testAttachmentsUpsertFail() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');

		
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			prepareWot(controller);
			insertTestBadAttachment(controller);
			controller.upsertAttachments();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
		
	}
	
	public static testMethod void testAttachmentsUpsertSuccess() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');

		
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			prepareWot(controller);
			insertTestAttachment(controller, tracker.Id);
			insertTestAttachment(controller, null);
			controller.wot.id = tracker.Id;
			tracker.id = null;
			insert tracker;
			controller.upsertAttachments();
			System.assertEquals(2, [SELECT count() FROM Attachment WHERE ParentId= :tracker.Id]);

			// delete attachments
			controller.getAttachments();
			for (Attachment at : controller.existingAttachmentsList) {
				// setting id that originally comes with the page as a parameter after click
				ApexPages.currentPage().getParameters().put('attId', at.Id);
				controller.removeAttachment();
			}       
			System.assertEquals(0, [SELECT count() FROM Attachment WHERE ParentId= :tracker.Id]);
		}
	}
	
	public static testMethod void testAttachmentsDMLException() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');

		
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) {
			test.startTest();
			controller.wot.Optimization_Tracker_Status__c = 'In Progress - Development Engineer';
			loc = createWellLocation();
			controller.wot.Well_Location__c = loc;
			insert tracker;
			insertTestBadAttachment(controller);
			controller.upsertAttachments();
			controller.wot.id = tracker.id;
			test.stopTest();
			System.assertEquals(0, [SELECT count() FROM Attachment WHERE ParentId= :tracker.Id]);
			// System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	private static void insertTestAttachment(CO_OptimizationTrackerEditExt controller, Id ParentId) {
		Attachment att = new Attachment();
		att.Name = 'testAtt1.txt';
		att.Body = Blob.valueOf('test att body1');
		att.parentId = ParentId;
		controller.attachmentsList.add(att);
	}
	
	private static void insertTestBadAttachment(CO_OptimizationTrackerEditExt controller) {
		Attachment att = new Attachment();
		att.Name = null;
		att.Body = Blob.valueOf('notnull');
		att.parentId = null;
		controller.attachmentsList.add(att);
	}


	private static void prepareWot(CO_OptimizationTrackerEditExt controller) {
		controller.wot.Optimization_Request__c = 'Downhole';
		controller.wot.Optimization_Category__c = 'Capital';
		controller.wot.Optimization_Tracker_Status__c = 'In Progress - Development Engineer';
		controller.wot.Opt_Type__c = 'Add Perfs';
		controller.wot.Predicted_Incremental_Oil_bopd__c = 5;
		controller.wot.Predicted_Incremental_Water_bwpd__c = 5;
		loc = createWellLocation();
		controller.wot.Well_Location__c = loc;
	}
	
	public static testMethod void testForTabActivation() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');

		
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			controller.wot.Optimization_Tracker_Status__c = null;
			System.assertEquals('DM', controller.getActiveTab());
			controller.wot.Optimization_Tracker_Status__c = controller.in_Progress_PE_Status;
			System.assertEquals('PE', controller.getActiveTab());
			controller.wot.Optimization_Tracker_Status__c = controller.in_Progress_G_Status;
			System.assertEquals('G', controller.getActiveTab());
			controller.wot.Optimization_Tracker_Status__c = controller.in_Progress_DE_Status;
			System.assertEquals('DE', controller.getActiveTab());
			controller.wot.Optimization_Tracker_Status__c = controller.approved_Status;
			System.assertEquals('PE', controller.getActiveTab());
			controller.wot.Asset_Manager_Review_Required__c = true;
			System.assertEquals('DM', controller.getActiveTab());
			controller.wot.Optimization_Tracker_Status__c = controller.cancelled_Status;
			System.assertEquals('PE', controller.getActiveTab());
			controller.wot.Optimization_Tracker_Status__c = controller.on_Hold_Status;
			System.assertEquals('PE', controller.getActiveTab());
			controller.wot.Optimization_Tracker_Status__c = controller.pending_Managers_Approval_Status;
			System.assertEquals('DM', controller.getActiveTab());
		}
	}
	
	public static testMethod void testBooleanMethods() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');

		
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			testShowCycleTimes(controller);
			testGetIsEdit(controller);
			testGetIsStatusActive(controller);
			testGetArePortionsCompleted(controller);
		}
	}
	
	private static void testShowCycleTimes(CO_OptimizationTrackerEditExt controller) {
		controller.wot.Current_State__c = null;
		controller.wot.Job_Complete_Date__c = null;
		System.assert(!controller.ShowCycleTimeDays());
		controller.wot.Current_State__c = controller.completed_Status;
		System.assert(!controller.ShowCycleTimeDays());
		controller.wot.Current_State__c = null;
		controller.wot.Job_Complete_Date__c = Date.today();
		System.assert(!controller.ShowCycleTimeDays());
		controller.wot.Current_State__c = controller.completed_Status;
		System.assert(controller.ShowCycleTimeDays());
	}
	
	private static void testGetIsEdit(CO_OptimizationTrackerEditExt controller) {
		// loc = createWellLocation();
		// Well_Optimization_Tracker__c wot = new Well_Optimization_Tracker__c(Well_Location__c = loc, Optimization_Tracker_Status__c = controller.in_Progress_PE_Status);
		// upsert wot;
		// controller.wot.id = wot.id;
		// System.assert(controller.getIsEdit());
		controller.wot.id = null;
		System.assert(!controller.getIsEdit());
	}
	
	private static void testGetIsStatusActive(CO_OptimizationTrackerEditExt controller) {
		controller.wot.Optimization_Tracker_Status__c = controller.approved_Status;
		System.assert(controller.getIsStatusActive());
		controller.wot.Optimization_Tracker_Status__c = controller.in_Progress_PE_Status;
		System.assert(controller.getIsStatusActive());
		controller.wot.Optimization_Tracker_Status__c = controller.in_Progress_G_Status;
		System.assert(controller.getIsStatusActive());
		controller.wot.Optimization_Tracker_Status__c = controller.in_Progress_DE_Status;
		System.assert(controller.getIsStatusActive());
		controller.wot.Optimization_Tracker_Status__c = controller.pending_Managers_Approval_Status;
		System.assert(controller.getIsStatusActive());
		controller.wot.Optimization_Tracker_Status__c = controller.on_Hold_Status;
		System.assert(!controller.getIsStatusActive());
		controller.wot.Optimization_Tracker_Status__c = controller.cancelled_Status;
		System.assert(!controller.getIsStatusActive());
	}
	
	private static void testGetArePortionsCompleted(CO_OptimizationTrackerEditExt controller) {
		controller.wot.Production_Engineer_Portion_Complete__c = false;
		controller.wot.Development_Engineer_Portion_Complete__c = false;
		controller.wot.Development_Engineer_Review_Required__c = true;
		controller.wot.Asset_Manager_Review_Required__c = true;
		controller.wot.Geologists_review_required__c = false;
		controller.wot.Geologist_Portion_Complete__c = false;
		System.assert(!controller.getArePortionsCompleted());
		controller.wot.Production_Engineer_Portion_Complete__c = true;
		System.assert(!controller.getArePortionsCompleted());
		controller.wot.Production_Engineer_Portion_Complete__c = false;
		controller.wot.Development_Engineer_Portion_Complete__c = true;
		System.assert(!controller.getArePortionsCompleted());
		controller.wot.Production_Engineer_Portion_Complete__c = true;
		System.assert(controller.getArePortionsCompleted());
		controller.wot.Production_Engineer_Portion_Complete__c = false;
		controller.wot.Development_Engineer_Portion_Complete__c = false;
		controller.wot.Geologists_review_required__c = true;
		System.assert(!controller.getArePortionsCompleted());
		controller.wot.Production_Engineer_Portion_Complete__c = true;
		System.assert(!controller.getArePortionsCompleted());
		controller.wot.Production_Engineer_Portion_Complete__c = false;
		controller.wot.Development_Engineer_Portion_Complete__c = true;
		System.assert(!controller.getArePortionsCompleted());
		controller.wot.Production_Engineer_Portion_Complete__c = true;
		controller.wot.Development_Engineer_Portion_Complete__c = true;
		System.assert(!controller.getArePortionsCompleted());
		controller.wot.Production_Engineer_Portion_Complete__c = false;
		controller.wot.Development_Engineer_Portion_Complete__c = false;
		controller.wot.Geologists_review_required__c = false;
		controller.wot.Geologist_Portion_Complete__c = true;
		System.assert(!controller.getArePortionsCompleted());
		controller.wot.Production_Engineer_Portion_Complete__c = true;
		controller.wot.Development_Engineer_Portion_Complete__c = false;
		System.assert(!controller.getArePortionsCompleted());
		controller.wot.Production_Engineer_Portion_Complete__c = false;
		controller.wot.Development_Engineer_Portion_Complete__c = true;
		System.assert(!controller.getArePortionsCompleted());
		controller.wot.Production_Engineer_Portion_Complete__c = true;
		controller.wot.Development_Engineer_Portion_Complete__c = true;
		System.assert(controller.getArePortionsCompleted());
		controller.wot.Production_Engineer_Portion_Complete__c = false;
		controller.wot.Development_Engineer_Portion_Complete__c = false;
		controller.wot.Geologists_review_required__c = true;
		System.assert(!controller.getArePortionsCompleted());
		controller.wot.Production_Engineer_Portion_Complete__c = true;
		controller.wot.Development_Engineer_Portion_Complete__c = false;
		System.assert(!controller.getArePortionsCompleted());
		controller.wot.Production_Engineer_Portion_Complete__c = false;
		controller.wot.Development_Engineer_Portion_Complete__c = true;
		System.assert(!controller.getArePortionsCompleted());
		controller.wot.Production_Engineer_Portion_Complete__c = true;
		System.assert(controller.getArePortionsCompleted());
	}
	
	public static testMethod void testForSetStatus() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');

		
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			controller.wot.Optimization_Request__c = 'Downhole';
			controller.wot.Optimization_Category__c = 'Capital';

			controller.wot.Optimization_Tracker_Status__c = controller.cancelled_Status;
			controller.setStatus();
			System.assertEquals(controller.cancelled_Status, controller.wot.Optimization_Tracker_Status__c);
			
			controller.wot.Optimization_Tracker_Status__c = controller.on_Hold_Status;
			controller.setStatus();
			System.assertEquals(controller.on_Hold_Status, controller.wot.Optimization_Tracker_Status__c);
			
			controller.wot.Optimization_Tracker_Status__c = controller.in_Progress_PE_Status;
			controller.setStatus();
			System.assertEquals(controller.in_Progress_PE_Status, controller.wot.Optimization_Tracker_Status__c);
			
			controller.wot.Optimization_Tracker_Status__c = controller.in_Progress_PE_Status;
			controller.wot.Production_Engineer_Portion_Complete__c = true;
			controller.setStatus();
			System.assertEquals(controller.approved_Status, controller.wot.Optimization_Tracker_Status__c);

			controller.wot.Development_Engineer_Review_Required__c = true;
			controller.setStatus();
			System.assertEquals(controller.in_Progress_DE_Status, controller.wot.Optimization_Tracker_Status__c);
			
			controller.wot.Optimization_Tracker_Status__c = controller.in_Progress_PE_Status;
			controller.wot.Geologists_review_required__c = true;
			controller.setStatus();
			System.assertEquals(controller.in_Progress_G_Status, controller.wot.Optimization_Tracker_Status__c);

			controller.wot.Optimization_Tracker_Status__c = controller.in_Progress_PE_Status;
			controller.wot.Geologist_Portion_Complete__c = true;
			controller.setStatus();
			System.assertEquals(controller.in_Progress_DE_Status, controller.wot.Optimization_Tracker_Status__c);
			
			controller.wot.Optimization_Tracker_Status__c = controller.in_Progress_PE_Status;
			controller.wot.Development_Engineer_Portion_Complete__c = true;
			controller.setStatus();
			System.assertEquals(controller.approved_Status, controller.wot.Optimization_Tracker_Status__c);

			controller.wot.Asset_Manager_Review_Required__c = true;
			controller.setStatus();
			System.assertEquals(controller.pending_Managers_Approval_Status, controller.wot.Optimization_Tracker_Status__c);
			
			controller.wot.Optimization_Tracker_Status__c = controller.in_Progress_PE_Status;
			controller.wot.Development_Management_Validation__c = true;
			controller.setStatus();
			System.assertEquals(controller.approved_Status, controller.wot.Optimization_Tracker_Status__c);

			controller.wot.Optimization_Tracker_Status__c = controller.in_Progress_PE_Status;
			controller.wot.Asset_Manager_Review_Required__c = false;
			controller.wot.Development_Engineer_Review_Required__c = false;
			controller.wot.Geologists_review_required__c = false;
			controller.wot.Geologist_Portion_Complete__c = false;
			controller.wot.Development_Management_Validation__c = false;
			controller.wot.Geologist_Portion_Complete__c = false;
			controller.wot.Production_Engineer_Portion_Complete__c = true;
			controller.setStatus();
			System.assertEquals(controller.approved_Status, controller.wot.Optimization_Tracker_Status__c);
		}
	}
	
	@isTest
	public static void testForValidations_01() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			controller.validateFields();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Optimization_Request__c = 'Downhole';
			controller.wot.Optimization_Category__c = 'Capital';
			controller.validateFields();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	@isTest
	public static void testForValidations_02() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			controller.validateFields();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Optimization_Request__c = 'Downhole';
			controller.wot.Optimization_Category__c = 'Capital';
			controller.wot.Optimization_Tracker_Status__c = 'In Progress - Development Engineer';
			controller.wot.Opt_Type__c = 'Add Perfs';
			controller.validateFields();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	@isTest
	public static void testForValidations_03() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) {
			Location__c testLocation = LocationTestData.createLocation(); 
			controller.validateFields();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Optimization_Request__c = 'Downhole';
			controller.wot.Optimization_Category__c = 'Capital';
			controller.wot.Optimization_Tracker_Status__c = 'In Progress - Development Engineer';
			controller.wot.Opt_Type__c = 'Add Perfs';
			controller.wot.Predicted_Incremental_Oil_bopd__c = 5;
			controller.wot.Predicted_Incremental_Water_bwpd__c = 5;
			controller.wot.Location_Event__c = 'Well Location';
			controller.wot.Well_Location__c = [SELECT id FROM Location__c LIMIT 1].id;
			controller.validateFields();
			System.assertEquals(0, ApexPages.getMessages().size());
		}
	}
	
	 @isTest(SeeAllData=true)
	 public static void testForValidations_04() {
		 User runningUser = createUser();
		 runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		 runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		 PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		 Test.setCurrentPage(pageRef);
		 Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		 ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		 CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		 System.runAs(runningUser) { 
			 //controller.validateFields();
			 System.debug(controller.getIsApproved());
			 System.assertEquals(0, ApexPages.getMessages().size());
			 controller.wot.Optimization_Request__c = 'Downhole';
			 controller.wot.Optimization_Category__c = 'Capital';
			 controller.wot.Optimization_Tracker_Status__c = controller.approved_Status;
			 controller.validateFields();
			 System.assertEquals(2, ApexPages.getMessages().size());
		 }
	 }

	 @isTest(SeeAllData=true)
	 public static void testForValidations_05() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');

		
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		
		//insert tracker;
		
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		
		System.runAs(runningUser) {
			tracker.Optimization_Request__c = 'Downhole';

			test.startTest();
			
			Location__c testLocation = LocationTestData.createLocation();
			controller.wot.Optimization_Category__c = 'Capital';
			tracker.Well_Location__c = testLocation.Id;
			
			// first exceptions
			tracker.Opt_Type__c = null;
			tracker.Optimization_Tracker_Status__c = controller.cancelled_Status;
			tracker.Reason__c = '';
			controller.saveTracker();

			// second exceptions
			tracker.Opt_Type__c = 'Add Perfs';
			tracker.Reason__c = 'On Hold Reason';
			controller.saveTracker();
			
			test.stopTest();
		}
	 }    

	@isTest static void TestValidationFields1() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();

		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(new ApexPages.StandardController(tracker));
		

		System.runAs(runningUser) {
			// pass first condition: getApproved()
			controller.wot.Optimization_Tracker_Status__c = approved_Status;
			controller.wot.Optimization_Request__c = 'Surface';
			controller.wot.Optimization_Category__c = 'Capital';
			Location__c testLocation = LocationTestData.createLocation();
			controller.wot.Well_Location__c = testLocation.Id;
			controller.wot.Predicted_Incremental_Oil_bopd__c = 11;
			controller.wot.Predicted_Incremental_Water_bwpd__c = 15;
			controller.wot.Panel_Approved_Date__c = Date.valueOf('2017-01-01');
			controller.wot.Current_State__c = completed_Status;
			controller.wot.Job_Complete_Date__c = Date.valueOf('2017-01-01');
			controller.wot.RMLC_Approval__c = complete_Status;
			controller.wot.RMLC_Complete_Date__c = Date.valueOf('2017-01-01');
			controller.wot.Regulatory_Approvals__c = complete_Status;
			controller.wot.Regulatory_Approvals_Complete_Date__c = Date.valueOf('2017-01-01');
			controller.wot.Financial_Approval__c = in_Progress_Status;
			controller.wot.Financial_Approval_Complete_Date__c = Date.valueOf('2017-01-01');
			controller.wot.Construction__c = complete_Status;
			controller.wot.Construction_Complete_Date__c = Date.today();
			controller.wot.Opt_Type__c = 'Recomplete -Plug Back - Bridge Plug';
			controller.wot.Construction_Berm__c = true;
			controller.wot.Construction_Access_Road_Upgrade__c = true;
			controller.wot.Construction_Lease_Upgrade__c = true;
			controller.wot.Downhole_Equipment__c = complete_Status;
			controller.wot.Downhole_Equipment_Complete_Date__c = Date.today();
			controller.wot.Surface_Equipment__c = complete_Status;
			controller.wot.Surface_Equipment_Complete_Date__c = Date.today();
			controller.wot.From_Location__c = 'TEST FROM LOCATION'; 
			controller.wot.Engine_Size__c = notRequired; 
			controller.wot.Type_of_Drive__c = notRequired;
			controller.wot.Tank_Size__c = notRequired;
			controller.wot.Type_of_Shack__c = notRequired;
			controller.wot.Correct_Signage__c = notRequired; 
			controller.wot.Containment__c = 'Berm';
			controller.wot.From_Location_Containment__c = 'TEST CONTAINMENT FROM';

			controller.validateFields();    
		}

	}

	@isTest static void TestValidationFields2() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();

		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(new ApexPages.StandardController(tracker));
		

		System.runAs(runningUser) {
			// pass first condition: getApproved()
			controller.wot.Optimization_Tracker_Status__c = approved_Status;
			controller.wot.Optimization_Request__c = 'Surface';
			controller.wot.Optimization_Category__c = 'Capital';
			controller.wot.Surface_Equipment__c = complete_Status;
			controller.wot.Surface_Equipment_Complete_Date__c = Date.today();
			controller.wot.From_Location__c = 'TEST FROM LOCATION'; 
			controller.wot.Containment__c = 'Berm';
			controller.wot.From_Location_Containment__c = 'TEST CONTAINMENT FROM';
			controller.wot.Engine_Size__c = notRequired; 
			controller.wot.Type_of_Drive__c = notRequired;
			controller.wot.Tank_Size__c = notRequired;
			controller.wot.Type_of_Shack__c = notRequired;
			controller.wot.Correct_Signage__c = notRequired;
			
			controller.validateFields();
		}

	}

	@isTest static void TestValidationFields3() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();

		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(new ApexPages.StandardController(tracker));

		System.runAs(runningUser) {
			// false-condition for getApproved()
			controller.wot.Optimization_Tracker_Status__c = '';
			controller.wot.Optimization_Request__c = '';
			controller.wot.Optimization_Category__c = '';
			controller.validateFields();
		}

	}

	public static testMethod void testForValicateRMLCDateField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			controller.validateRMLCDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = System.today();
			controller.validateRMLCDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = null;
			controller.wot.RMLC_Complete_Date__c = System.today().addDays(-1);
			controller.validateRMLCDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = System.today();
			controller.validateRMLCDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = System.today().addDays(-2);
			controller.validateRMLCDateField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}

	public static testMethod void testForValicateRegulatoryDateField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			controller.validateRegulatoryDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = System.today();
			controller.validateRegulatoryDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = null;
			controller.wot.Regulatory_Approvals_Complete_Date__c = System.today().addDays(-1);
			controller.validateRegulatoryDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = System.today();
			controller.validateRegulatoryDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = System.today().addDays(-2);
			controller.validateRegulatoryDateField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}

	public static testMethod void testForValicateFinancialDateField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			controller.validateFinancialDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = System.today();
			controller.validateFinancialDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = null;
			controller.wot.Financial_Approval_Complete_Date__c = System.today().addDays(-1);
			controller.validateFinancialDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = System.today();
			controller.validateFinancialDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = System.today().addDays(-2);
			controller.validateFinancialDateField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}

	public static testMethod void testForValicateConstructionDateField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			controller.validateConstructionDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = System.today();
			controller.validateConstructionDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = null;
			controller.wot.Construction_Complete_Date__c = System.today().addDays(-1);
			controller.validateConstructionDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = System.today();
			controller.validateConstructionDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = System.today().addDays(-2);
			controller.validateConstructionDateField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}

	public static testMethod void testForValicateSurfaceEqDateDateField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			controller.validateSurfaceEquipmentDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = System.today();
			controller.validateSurfaceEquipmentDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = null;
			controller.wot.Surface_Equipment_Complete_Date__c = System.today().addDays(-1);
			controller.validateSurfaceEquipmentDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = System.today();
			controller.validateSurfaceEquipmentDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Job_Complete_Date__c = System.today().addDays(-2);
			controller.validateSurfaceEquipmentDateField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}

	public static testMethod void testForValicateJobCompleteDateDateField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Current_State__c = controller.completed_Status;
			controller.wot.Job_Complete_Date__c = System.today();
			controller.validateJobCompleteDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Current_State__c = null;
			controller.validateJobCompleteDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Current_State__c = controller.completed_Status;
			controller.wot.Job_Complete_Date__c = null;
			controller.validateJobCompleteDateField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}

	public static testMethod void testForValicateRMLCCompleteDateDateField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.RMLC_Approval__c = controller.complete_Status;
			controller.wot.RMLC_Complete_Date__c = System.today();
			controller.validateRMLCCompleteDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.RMLC_Approval__c = null;
			controller.validateRMLCCompleteDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.RMLC_Approval__c = controller.complete_Status;
			controller.wot.RMLC_Complete_Date__c = null;
			controller.validateRMLCCompleteDateField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}

	public static testMethod void testForValicateRegulatoryApprovalCompleteDateDateField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Regulatory_Approvals__c = controller.complete_Status;
			controller.wot.Regulatory_Approvals_Complete_Date__c = System.today();
			controller.validateRegulatoryApprovalsCompleteDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Regulatory_Approvals__c = null;
			controller.validateRegulatoryApprovalsCompleteDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Regulatory_Approvals__c = controller.complete_Status;
			controller.wot.Regulatory_Approvals_Complete_Date__c = null;
			controller.validateRegulatoryApprovalsCompleteDateField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}

	public static testMethod void testForValicateFinancialApprovalCompleteDateDateField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Financial_Approval__c = controller.complete_Status;
			controller.wot.Financial_Approval_Complete_Date__c = System.today();
			controller.validateFinancialApprovalCompleteDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Financial_Approval__c = null;
			controller.validateFinancialApprovalCompleteDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Financial_Approval__c = controller.complete_Status;
			controller.wot.Financial_Approval_Complete_Date__c = null;
			controller.validateFinancialApprovalCompleteDateField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}

	public static testMethod void testForValicateConstructionCompleteDateDateField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Construction__c = controller.complete_Status;
			controller.wot.Construction_Complete_Date__c = System.today();
			controller.validateConstructionCompleteDate();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Construction__c = null;
			controller.validateConstructionCompleteDate();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Construction__c = controller.complete_Status;
			controller.wot.Construction_Complete_Date__c = null;
			controller.validateConstructionCompleteDate();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}

	public static testMethod void testForValicateSurfaceEqCompleteDateDateField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Surface_Equipment__c = controller.complete_Status;
			controller.wot.Surface_Equipment_Complete_Date__c = System.today();
			controller.validateSurfaceEquipmentCompleteDate();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Surface_Equipment__c = null;
			controller.validateSurfaceEquipmentCompleteDate();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Surface_Equipment__c = controller.complete_Status;
			controller.wot.Surface_Equipment_Complete_Date__c = null;
			controller.validateSurfaceEquipmentCompleteDate();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}

	public static testMethod void testForValidateConstructionBernAccessAndLeaseFields() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Construction__c = null;
			controller.validateConstructionBernAccessAndLeaseFields();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Construction__c = controller.in_Progress_Status;
			controller.wot.Construction_Berm__c = true;
			controller.wot.Construction_Access_Road_Upgrade__c = true;
			controller.wot.Construction_Lease_Upgrade__c = true;
			controller.validateConstructionBernAccessAndLeaseFields();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Construction__c = controller.in_Progress_Status;
			controller.wot.Construction_Berm__c = false;
			controller.validateConstructionBernAccessAndLeaseFields();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Construction_Berm__c = true;
			controller.wot.Construction_Access_Road_Upgrade__c = false;
			controller.validateConstructionBernAccessAndLeaseFields();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Construction_Berm__c = false;
			controller.validateConstructionBernAccessAndLeaseFields();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Construction_Berm__c = true;
			controller.wot.Construction_Access_Road_Upgrade__c = true;
			controller.wot.Construction_Lease_Upgrade__c = false;
			controller.validateConstructionBernAccessAndLeaseFields();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Construction_Berm__c = false;
			controller.validateConstructionBernAccessAndLeaseFields();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Construction_Berm__c = true;
			controller.wot.Construction_Access_Road_Upgrade__c = false;
			controller.validateConstructionBernAccessAndLeaseFields();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Construction_Berm__c = false;
			controller.validateConstructionBernAccessAndLeaseFields();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	public static testMethod void testForValidateSurfaceEqField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Surface_Equipment__c = controller.complete_Status;
			controller.validateSurfaceEquipmentField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Surface_Equipment__c = null;
			controller.validateSurfaceEquipmentField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	public static testMethod void testForValidateFromLocationField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.From_Location__c = 'test';
			controller.validateFromLocationField();
			System.assertEquals(0, ApexPages.getMessages().size());

			//added on 28.4.2017
			controller.wot.From_Location_Containment__c = 'test';
			controller.validateFromLocationContainmentField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.From_Location__c = null;
			controller.validateFromLocationField();
			System.assertEquals(1, ApexPages.getMessages().size());

			//added on 28.4.2017
			controller.wot.From_Location_Containment__c = null;
			controller.validateFromLocationContainmentField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	public static testMethod void testForValidateEngineSizeField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Engine_Size__c = 'Not Required';
			controller.validateEngineSizeField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Engine_Size__c = null;
			controller.validateEngineSizeField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	public static testMethod void testForValidateTypeOfDriveField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Type_of_Drive__c = 'Not Required';
			controller.validateTypeOfDriveField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Type_of_Drive__c = null;
			controller.validateTypeOfDriveField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	public static testMethod void testForValidateTankSizeField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Tank_Size__c = 'Not Required';
			controller.validateTankSizeField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Tank_Size__c = null;
			controller.validateTankSizeField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	public static testMethod void testForValidateTypeOfShackField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Type_of_Shack__c = 'Not Required';
			controller.validateTypeOfShackField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Type_of_Shack__c = null;
			controller.validateTypeOfShackField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	public static testMethod void testForValidateCorrectSignageField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Correct_Signage__c = 'Not Required';
			controller.validateCorrectSignageField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Correct_Signage__c = null;
			controller.validateCorrectSignageField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	public static testMethod void testForValidateContainmentField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Containment__c = 'No';
			controller.validateContainmentField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Containment__c = null;
			controller.validateContainmentField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	public static testMethod void testForValidateOptTypeField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Optimization_Category__c = 'Capital';
			controller.wot.Optimization_Request__c = 'Downhole';
			
			controller.wot.Opt_Type__c = 'Add Perfs';
			controller.validateOptTypeField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Opt_Type__c = null;
			controller.validateOptTypeField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	public static testMethod void testForValidateApprovedDateField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Panel_Approved_Date__c = System.today();
			controller.validatePanelApprovedDateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Panel_Approved_Date__c = null;
			controller.validatePanelApprovedDateField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	public static testMethod void testForValidateCurrentStateField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Current_State__c = controller.completed_Status;
			controller.validateCurrentStateField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Current_State__c = null;
			controller.validateCurrentStateField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	public static testMethod void testForValidateRMLCApprovalsField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.RMLC_Approval__c = controller.complete_Status;
			controller.validateRMLCApprovalField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.RMLC_Approval__c = null;
			controller.validateRMLCApprovalField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	public static testMethod void testForValidateRegulatoryApprovalsField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Regulatory_Approvals__c = controller.complete_Status;
			controller.validateRegulatoryApprovalsField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Regulatory_Approvals__c = null;
			controller.validateRegulatoryApprovalsField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	public static testMethod void testForValidateFinancialApprovalsField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Financial_Approval__c = controller.complete_Status;
			controller.validateFinancialApprovalField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Financial_Approval__c = null;
			controller.validateFinancialApprovalField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	public static testMethod void testForValidateConstructionField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Construction__c = controller.complete_Status;
			controller.validateConstructionField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Construction__c = null;
			controller.validateConstructionField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	@isTest
	public static void testForValidateWellLocationField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			Location__c testLocation = LocationTestData.createLocation();
			System.assertEquals(0, ApexPages.getMessages().size());
			controller.wot.Location_Event__c = 'Well Location';
			
			controller.wot.Well_Location__c = [SELECT id FROM Location__c LIMIT 1].id;
			controller.validateWellLocationField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Well_Location__c = null;
			controller.validateWellLocationField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	@isTest
	public static void testForValidatePredictedIncrementalOilField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Predicted_Incremental_Oil_bopd__c = 5;
			controller.validatePredictedInceremtalOilField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Predicted_Incremental_Oil_bopd__c = null;
			controller.validatePredictedInceremtalOilField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	@isTest
	public static void testForValidatePredictedIncrementalWaterField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Predicted_Incremental_Water_bwpd__c = 5;
			controller.validatePredictedIncrementalWaterField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Predicted_Incremental_Water_bwpd__c = null;
			controller.validatePredictedIncrementalWaterField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	@isTest
	public static void testForValidateStatusField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Optimization_Tracker_Status__c = controller.approved_Status;
			controller.validateStatusField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Optimization_Tracker_Status__c = null;
			controller.validateStatusField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	
	@isTest
	public static void testForValidateReasonField() {
		User runningUser = createUser();
		runningUser = assignPermissionSet(runningUser, 'HOG_Service_Rig_Program_Read_Write');
		runningUser = assignProfile(runningUser, 'Standard HOG - General User');
		PageReference pageRef = Page.CO_OptimizationTrackerEditV2;
		Test.setCurrentPage(pageRef);
		Well_Optimization_Tracker__c tracker = new Well_Optimization_Tracker__c();
		ApexPages.StandardController stdController = new ApexPages.StandardController(tracker);
		CO_OptimizationTrackerEditExt controller = new CO_OptimizationTrackerEditExt(stdController);
		System.runAs(runningUser) { 
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Reason__c = 'test';
			controller.validateReasonField();
			System.assertEquals(0, ApexPages.getMessages().size());
			
			controller.wot.Reason__c = null;
			controller.validateReasonField();
			System.assertEquals(1, ApexPages.getMessages().size());
		}
	}
	

	
	
	private static String createWellLocation() {
		if (CO_OptimizationTrackerEditExtTest.loc == null) {
		//create test BU
			Business_Unit__c  testbu = FM_RunSheetTestData.createBusinessUnit('Test BU',  true);
	
			//create test BD            
			Business_Department__c testbd = FM_RunSheetTestData.createBusinessDepartment('Test BD',  true);
			//create test OD
			Operating_District__c testOD = FM_RunSheetTestData.createOperatingDistrict('Test OD', testbd.Id, testbu.Id,  true) ;
			//create test field
			Field__c testField = FM_RunSheetTestData.createField('Test Field', testOD.Id, true) ;
			//create test route
			//Route__c testRoute = FM_RunSheetTestData.createRoute('999', true);
			Route__c testRoute = new Route__c
			  (
				  Name = '999',
				  Route_Number__c = '999'
			  );     
			  insert testRoute;
			  
			//create test well
			Location__c location = FM_RunSheetTestData.createLocation('Test Well 1', testField.id, testRoute.id , false, true);
			//we need location with category = 4
			location.Functional_Location_Category__c =4;
			location.Well_Type__c = 'Oil';
			//and setup unit configuration
			location.Unit_Configuration__c = 'T5X';
			location.Status__c = 'PROD';
			location.RecordTypeId = [SELECT ID FROM RecordType WHERE DeveloperName = 'Well_ID' LIMIT 1].Id;
			upsert location;
			return location.id;
		}
		return loc;
	}
	
	private static User createUser(){
	
		User user = new User();
		Profile p = [Select Id from Profile where Name='Standard HOG - General User'];
		
		Double random = Math.Random();

		user.email = 'COTUser' +  random + '@cot.com';
		user.Alias = 'COTUser' ;
		user.EmailEncodingKey = 'UTF-8';
		user.LastName = 'User';
		user.LanguageLocaleKey = 'en_US'; 
		user.LocaleSidKey = 'en_US'; 
		user.ProfileId = p.Id;
		user.TimeZoneSidKey = 'America/Los_Angeles'; 
		user.UserName = 'COTUser' + random + '@cot.com.unittest';
		
		insert user;
		System.debug('User returned: ' +user);
		return user;
	}
	
   private static User assignPermissionSet(User user, String userPermissionSetName){
	
		PermissionSet permissionSet = [SELECT Id FROM PermissionSet WHERE Name =: userPermissionSetName]; 
		PermissionSetAssignment permissionSetAssignment = new PermissionSetAssignment();
		
		permissionSetAssignment.PermissionSetId = permissionSet.Id;
		permissionSetAssignment.AssigneeId = user.Id; 
		
		insert permissionSetAssignment;
			
		return user;
	}
	
   private static User assignProfile (User user, String profileName){
   
	   Profile profile = [SELECT Id FROM Profile WHERE Name =: profileName];
	   user.ProfileId = profile.Id;
	   update user;
	   return user;   
   } 
}